(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */

	$(document).ready(function(){
		// $('[data-toggle="popover"]').popover();
		$('[data-toggle="tooltip"]').tooltip();

		// $(document).find("#ays_pd_default_sorting_points").not('.ays-select-search').select2({
		// 	minimumResultsForSearch: -1
		// });

		// WP color picker start
		var defaultColors = {
			bgColor: "#ffffff",
			mainColor: "#3f72af",
			textColor: "#000",
			buttonsTextColor: "#ffffff",
			titleBoxShadowColor: "rgba(234,234,234,0)",
		};

		var ays_pd_bg_color_picker = {
            defaultColor: defaultColors.bgColor,
			change: function (e) {
                
            }
        };

		var ays_pd_main_color_picker = {
            defaultColor: defaultColors.mainColor,
			change: function (e) {
                
            }
        };

		var ays_pd_text_color_picker = {
            defaultColor: defaultColors.textColor,
			change: function (e) {
                
            }
        };
		
		var ays_pd_buttonsText_color_picker = {
            defaultColor: defaultColors.buttonsTextColor,
			change: function (e) {
                
            }
        };

        var ays_pd_titleBoxShadow_color_picker = {
            defaultColor: defaultColors.titleBoxShadowColor,
			change: function (e) {
                
            }
        };

		$(document).find('#ays_pd_bg_color').wpColorPicker(ays_pd_bg_color_picker);
		$(document).find('#ays_pd_main_color').wpColorPicker(ays_pd_main_color_picker);
		$(document).find('#ays_pd_text_color').wpColorPicker(ays_pd_text_color_picker);
		$(document).find('#ays_pd_button_text_color').wpColorPicker(ays_pd_buttonsText_color_picker);
		$(document).find('#ays_pd_title_text_shadow_color').wpColorPicker(ays_pd_titleBoxShadow_color_picker);
		// WP color picker end


		// Code Mirror
			
		setTimeout(function(){
			if($(document).find('#ays_custom_css').length > 0){
				let CodeEditor = null;
				if(wp.codeEditor){
					CodeEditor = wp.codeEditor.initialize($(document).find('#ays_custom_css'), cm_settings);
				}
				if(CodeEditor !== null){
					CodeEditor.codemirror.on('change', function(e, ev){
						$(CodeEditor.codemirror.display.input.div).find('.CodeMirror-linenumber').remove();
						$(document).find('#ays_custom_css').val(CodeEditor.codemirror.display.input.div.innerText);
							
					});
				}
			

			}
        }, 500);
       
		$(document).find('a[href="#tab2"]').on('click', function (e) {        
            setTimeout(function(){
                if($(document).find('#ays_custom_css').length > 0){
                    var ays_custom_css = $(document).find('#ays_custom_css').html();
                    if(wp.codeEditor){
                        $(document).find('#ays_custom_css').next('.CodeMirror').remove();
                        var CodeEditor = wp.codeEditor.initialize($(document).find('#ays_custom_css'), cm_settings);

                        CodeEditor.codemirror.on('change', function(e, ev){
                            $(CodeEditor.codemirror.display.input.div).find('.CodeMirror-linenumber').remove();
                            $(document).find('#ays_custom_css').val(CodeEditor.codemirror.display.input.div.innerText);
                        });
                        ays_custom_css = CodeEditor.codemirror.getValue();
                        $(document).find('#ays_custom_css').html(ays_custom_css);
                    }
                }
            }, 500);
           
        });

		let toggle_ddmenu = $(document).find('.toggle_ddmenu');
        toggle_ddmenu.on('click', function () {
            let ddmenu = $(this).next();
            let state = ddmenu.attr('data-expanded');
            switch (state) {
                case 'true':
                    $(this).find('.ays_fa_pd').css({
                        transform: 'rotate(0deg)'
                    });
                    ddmenu.attr('data-expanded', 'false');
                    break;
                case 'false':
                    $(this).find('.ays_fa_pd').css({
                        transform: 'rotate(90deg)'
                    });
                    ddmenu.attr('data-expanded', 'true');
                    break;
            }
        });

		$(document).find('input.ays_pd_shortcode').on('mouseleave', function(){
            var _this = $(this);

            _this.attr( 'data-original-title', pdAdminLangObj.clickForCopy );
			_this.tooltip("hide");
        });

		$(document).keydown(function(event) {
            var editButton = $(document).find("input#ays_pd_submit_top");
            if (!(event.which == 83 && event.ctrlKey) && !(event.which == 19)){
                return true;  
            }

            editButton.trigger("click");
            event.preventDefault();
            return false;
        });

		var subButtons = '.button#ays_pd_submit_top';
		$(document).on('click', subButtons ,function () {     
			var $this = $(this);
			submitOnce($this);
		});

		function submitOnce(subButton){
			var subLoader = subButton.siblings(".display_none");
			subLoader.removeClass("display_none");
			subLoader.css("padding-left" , "8px");
			subLoader.css("display" , "inline-block");
			setTimeout(function() {
				$(subButtons).attr('disabled', true);
			}, 50);
			setTimeout(function() {
				$(subButtons).attr('disabled', false);
				subLoader.addClass("display_none");
			}, 5000);
		}

		$(document).on('change', '.ays_toggle', function (e) {
            var state = $(this).prop('checked');
            if($(this).hasClass('ays_toggle_slide')){
                switch (state) {
                    case true:
                        $(this).parent().find('.ays_toggle_target').slideDown(250);
                        break;
                    case false:
                        $(this).parent().find('.ays_toggle_target').slideUp(250);
                        break;
                }
            }else{
                switch (state) {
                    case true:
                        $(this).parent().find('.ays_toggle_target').show(250);
                        break;
                    case false:
                        $(this).parent().find('.ays_toggle_target').hide(250);
                        break;
                }
            }
        });

	});
	
})( jQuery );

function selectElementContents(el) {
	if (window.getSelection && document.createRange) {
		var _this = jQuery(document).find('input.ays_pd_shortcode');
		var _thisVal = _this.val();
		
		_this.select();
		document.execCommand('copy');
		
		_this.attr( "data-original-title", pdAdminLangObj.copied );
		_this.attr( "title", pdAdminLangObj.copied );

		_this.tooltip("show");

	} else if (document.selection && document.body.createTextRange) {
		var textRange = document.body.createTextRange();
		textRange.moveToElementText(el);
		textRange.select();
	}
}
