<?php
    class Personal_Dictionary_Settings_Actions{
        private $plugin_name;

        public function __construct($plugin_name) {
            $this->plugin_name = $plugin_name;
        }

        // Store Global settings
        public function ays_pd_store_global_settings(){
            global $wpdb;

            // Default options
            $meta_options = array(
                // "check_true_count"           => "4",
                "learned_points"                => 10,
                "right_points"                  => 1,
                "wrong_points"                  => -0.25,
                "enable_full_screen_mode"       => "off",

                "show_correct_answer"           => "off",
                // "word_sorting"               => "word",
                "bg_color"                      => "#ffffff",
                "main_color"                    => "#3f72af",
                "text_color"                    => "#ffffff",
                "button_text_color"             => "#ffffff",
                "button_font_size"              => 16,
                "buttons_left_right_padding"    => 20,
                "buttons_top_bottom_padding"    => 10,
                "buttons_border_radius"         => 3,
                "question_font_size"            => 16,
                "question_font_size_for_mobile" => 16,
                "answer_font_size"              => 15,
                "answer_font_size_for_mobile"   => 15,
                "custom_class"                  => "",
                "custom_css"                    => "",
                "title"                         => "Dictionary",
                "show_title"                    => "on",
                "enable_title_text_shadow"      => "off",
                "title_text_shadow_color"       => "#333",
                "title_text_shadow_x_offset"    => 2,
                "title_text_shadow_y_offset"    => 2,
                "title_text_shadow_z_offset"    => 2,
                "title_alignment"               => "left",
                "pd_description"                => "",
                "description_font_size"         => 18,
                "description_font_size_for_mobile" => 18,
                "button_font_size_for_mobile"   => 16,
            );

            if( isset( $_POST["ays_pd_submit_top"] ) ){
                // Update options after save
                // $check_true_count     = isset($_POST['ays_pd_true_check_count']) && $_POST['ays_pd_true_check_count'] != '' ? sanitize_text_field($_POST['ays_pd_true_check_count']) : "4";
                $learned_points = isset($_POST['ays_pd_learned_points']) && $_POST['ays_pd_learned_points'] != '' ? floatval( sanitize_text_field( $_POST['ays_pd_learned_points'] ) ) : 10;
                $right_points = isset($_POST['ays_pd_right_points']) && $_POST['ays_pd_right_points'] != '' ? floatval( sanitize_text_field( $_POST['ays_pd_right_points'] ) ) : 1;
                $wrong_points = isset($_POST['ays_pd_wrong_points']) && $_POST['ays_pd_wrong_points'] != '' ? floatval( sanitize_text_field( $_POST['ays_pd_wrong_points'] ) ) : -0.25;
                $enable_full_screen_mode = isset($_POST['ays_pd_enable_full_screen_mode']) && $_POST['ays_pd_enable_full_screen_mode'] == 'on' ? 'on' : 'off';
                $show_correct_answer  = isset($_POST['ays_pd_show_correct_answer']) && $_POST['ays_pd_show_correct_answer'] == 'on' ? "on" : "off";
                // $word_sorting         = isset($_POST['ays_pd_default_sorting_points']) && $_POST['ays_pd_default_sorting_points'] != '' ? sanitize_text_field($_POST['ays_pd_default_sorting_points']) : "word";
                $bg_color   = isset($_POST['ays_pd_bg_color']) && $_POST['ays_pd_bg_color'] != '' ? sanitize_text_field( $_POST['ays_pd_bg_color'] ) : "#ffffff";
                $main_color = isset($_POST['ays_pd_main_color']) && $_POST['ays_pd_main_color'] != '' ? sanitize_text_field( $_POST['ays_pd_main_color'] ) : "#3f72af";
                $text_color = isset($_POST['ays_pd_text_color']) && $_POST['ays_pd_text_color'] != '' ? sanitize_text_field( $_POST['ays_pd_text_color'] ) : "#000";
                $button_text_color = isset($_POST['ays_pd_button_text_color']) && $_POST['ays_pd_button_text_color'] != '' ? sanitize_text_field( $_POST['ays_pd_button_text_color'] ) : "#ffffff";
                $button_font_size = isset($_POST['ays_pd_buttons_font_size']) && $_POST['ays_pd_buttons_font_size'] != '' ? absint( sanitize_text_field( $_POST['ays_pd_buttons_font_size'] )) : 16;
                $buttons_left_right_padding = isset($_POST['ays_pd_buttons_left_right_padding']) && $_POST['ays_pd_buttons_left_right_padding'] != '' ? absint( sanitize_text_field( $_POST['ays_pd_buttons_left_right_padding'] )) : 20;
                $button_font_size_for_mobile = isset($_POST['ays_pd_buttons_font_size_for_mobile']) && $_POST['ays_pd_buttons_font_size_for_mobile'] != '' && $_POST['ays_pd_buttons_font_size_for_mobile'] != 0 ? absint( sanitize_text_field($_POST['ays_pd_buttons_font_size_for_mobile'] )) : 16;
                $buttons_top_bottom_padding = isset($_POST['ays_pd_buttons_top_bottom_padding']) && $_POST['ays_pd_buttons_top_bottom_padding'] != '' ? absint( sanitize_text_field( $_POST['ays_pd_buttons_top_bottom_padding'] )) : 10;
                $buttons_border_radius = isset($_POST['ays_pd_buttons_border_radius']) && $_POST['ays_pd_buttons_border_radius'] != '' ? absint( sanitize_text_field( $_POST['ays_pd_buttons_border_radius'] )) : 3;

                //Question font size
                $question_font_size = isset($_POST['ays_pd_question_font_size']) && $_POST['ays_pd_question_font_size'] != '' ? absint( sanitize_text_field($_POST['ays_pd_question_font_size'] )) : 16;

                //Question font size for mobile
                $question_font_size_for_mobile = isset($_POST['ays_pd_question_font_size_for_mobile']) && $_POST['ays_pd_question_font_size_for_mobile'] != '' ? absint( sanitize_text_field($_POST['ays_pd_question_font_size_for_mobile'] )) : 16;

                //Answer font size
                $answer_font_size = isset($_POST['ays_pd_answer_font_size']) && $_POST['ays_pd_answer_font_size'] != '' ? absint( sanitize_text_field($_POST['ays_pd_answer_font_size'] )) : 15;

                //Answer font size for mobile
                $answer_font_size_for_mobile = isset($_POST['ays_pd_answer_font_size_for_mobile']) && $_POST['ays_pd_answer_font_size_for_mobile'] != '' ? absint( sanitize_text_field($_POST['ays_pd_answer_font_size_for_mobile'] )) : 15;

                $custom_class = (isset($_POST['ays_custom_class']) && sanitize_text_field( $_POST['ays_custom_class'] ) != "") ? sanitize_text_field( $_POST['ays_custom_class'] ) : '';

                if( isset($_POST['ays_pd_custom_css']) && $_POST['ays_pd_custom_css'] != '' ){
                    if( function_exists( 'sanitize_textarea_field' ) ){
                        $custom_css = sanitize_textarea_field( $_POST['ays_pd_custom_css'] );
                    }else{
                        $custom_css =  stripslashes ( esc_attr( $_POST['ays_pd_custom_css'] ));
                    }
                }else{
                    $custom_css = "";
                }

                $ays_pd_title = (isset($_POST['ays_pd_title']) && sanitize_text_field( $_POST['ays_pd_title'] ) != "") ? sanitize_text_field( $_POST['ays_pd_title'] ) : 'Dictionary';

                $ays_show_pd_title = (isset($_POST['ays_pd_show_title']) && sanitize_text_field( $_POST['ays_pd_show_title'] ) == "on") ? 'on' : 'off';  

                $enable_title_text_shadow = (isset($_POST['ays_pd_enable_title_text_shadow']) && $_POST['ays_pd_enable_title_text_shadow'] == 'on') ? 'on' : 'off';

                $title_text_shadow_color = (isset($_POST['ays_pd_title_text_shadow_color']) && $_POST['ays_pd_title_text_shadow_color'] != '') ? esc_attr($_POST['ays_pd_title_text_shadow_color']) : '#333';   

                $title_text_shadow_x_offset = (isset($_POST['ays_pd_title_text_shadow_x_offset']) && ( $_POST['ays_pd_title_text_shadow_x_offset'] ) != '' && ( $_POST['ays_pd_title_text_shadow_x_offset'] ) != 0) ? esc_attr( intval( $_POST['ays_pd_title_text_shadow_x_offset'] ) ) : 2;

                 $title_text_shadow_y_offset = (isset($_POST['ays_pd_title_text_shadow_y_offset']) && ($_POST['ays_pd_title_text_shadow_y_offset']) != '' && ($_POST['ays_pd_title_text_shadow_y_offset']) != 0) ? esc_attr( intval( $_POST['ays_pd_title_text_shadow_y_offset']) ) : 2; 

                  $title_text_shadow_z_offset = (isset($_POST['ays_pd_title_text_shadow_z_offset']) && ($_POST['ays_pd_title_text_shadow_z_offset']) != '' && ($_POST['ays_pd_title_text_shadow_z_offset']) != 0) ? esc_attr( intval($_POST['ays_pd_title_text_shadow_z_offset']) ) : 2;  

                  //Title Allignment
                  $pd_title_alignment    = ( isset($_POST['ays_pd_title_alignment']) && $_POST['ays_pd_title_alignment'] != "" ) ? sanitize_text_field($_POST['ays_pd_title_alignment']) : "left";

                  //PD Description
                  $pd_description = (isset($_POST['ays_pd_description']) && sanitize_text_field( $_POST['ays_pd_description'] ) != "") ? wp_kses_post($_POST['ays_pd_description']) : '';

                  $show_pd_description = (isset($_POST['ays_pd_show_description']) && sanitize_text_field( $_POST['ays_pd_show_description'] ) == "on") ? 'on' : 'off';

                  $description_font_size = isset($_POST['ays_pd_description_font_size']) && $_POST['ays_pd_description_font_size'] != '' && $_POST['ays_pd_description_font_size'] != 0 ? absint( sanitize_text_field( $_POST['ays_pd_description_font_size'] )) : 18;
                  $description_font_size_for_mobile = isset($_POST['ays_pd_description_font_size_for_mobile']) && $_POST['ays_pd_description_font_size_for_mobile'] != '' && $_POST['ays_pd_description_font_size_for_mobile'] != 0 ? absint( sanitize_text_field($_POST['ays_pd_description_font_size_for_mobile'] )) : 18;
                // Set options
                // $meta_options['check_true_count']    = $check_true_count;
                $meta_options['learned_points'] = $learned_points;
                $meta_options['right_points'] = $right_points;
                $meta_options['wrong_points'] = $wrong_points;
                $meta_options['enable_full_screen_mode'] = $enable_full_screen_mode;
                $meta_options['show_correct_answer'] = $show_correct_answer;
                // $meta_options['word_sorting']        = $word_sorting;
                $meta_options['bg_color']   = $bg_color;
                $meta_options['main_color'] = $main_color;
                $meta_options['text_color'] = $text_color;
                $meta_options['button_text_color'] = $button_text_color;
                $meta_options['button_font_size'] = $button_font_size;
                $meta_options['button_font_size_for_mobile'] = $button_font_size_for_mobile;
                $meta_options['buttons_left_right_padding'] = $buttons_left_right_padding;
                $meta_options['buttons_top_bottom_padding'] = $buttons_top_bottom_padding;
                $meta_options['buttons_border_radius'] = $buttons_border_radius;
                $meta_options['question_font_size'] = $question_font_size;
                $meta_options['question_font_size_for_mobile'] = $question_font_size_for_mobile;
                $meta_options['answer_font_size'] = $answer_font_size;
                $meta_options['answer_font_size_for_mobile'] = $answer_font_size_for_mobile;
                $meta_options['custom_class'] = $custom_class;
                $meta_options['custom_css'] = $custom_css;
                $meta_options['title'] = $ays_pd_title;
                $meta_options['show_title'] = $ays_show_pd_title;
                $meta_options['enable_title_text_shadow'] = $enable_title_text_shadow;
                $meta_options['title_text_shadow_color'] = $title_text_shadow_color;
                $meta_options['title_text_shadow_x_offset'] = $title_text_shadow_x_offset;
                $meta_options['title_text_shadow_y_offset'] = $title_text_shadow_y_offset;
                $meta_options['title_text_shadow_z_offset'] = $title_text_shadow_z_offset;
                $meta_options['title_alignment'] = $pd_title_alignment;
                $meta_options['pd_description'] = $pd_description;
                $meta_options['show_description'] = $show_pd_description;
                $meta_options['description_font_size'] = $description_font_size;
                $meta_options['description_font_size_for_mobile'] = $description_font_size_for_mobile;
                $global_settings = $this->ays_pd_get_setting();
                if(!$global_settings){
                    $global_settings = array();
                }
                $added_values = array_diff_key($meta_options , $global_settings);
                if(!$global_settings){
                    $result = $this->ays_pd_add_setting($meta_options,"", "");
                }
                else if(!empty($added_values)){
                    $result = $this->ays_pd_add_setting($added_values,"", "");
                }
                else{
                    $result = $this->ays_pd_update_setting($meta_options ,"", "");
                }
            }
        }

        // Add global settings
        public static function ays_pd_add_setting($metas , $note = "", $options = ""){
            global $wpdb;
            $dictionary_global_settings = esc_sql( $wpdb->prefix . PERSONAL_DICTIONARY_DB_PREFIX . "globsettings" );
            if(isset($metas) && !empty($metas)){
                foreach($metas as $m_key => $m_value){
                    $result = $wpdb->insert(
                        $dictionary_global_settings,
                        array(
                            'meta_key'   => $m_key,
                            'meta_value' => $m_value,
                            'note'       => "",
                            'options'    => ""
                        ),
                        array( '%s', '%s', '%s', '%s' )
                    );

                }
                if($result >= 0){
                    return true;
                }
            }
            return false;
        }

        // Update global settings
        public static function ays_pd_update_setting($metas, $notes = "", $options = ""){
            global $wpdb;
            $dictionary_global_settings = esc_sql( $wpdb->prefix . PERSONAL_DICTIONARY_DB_PREFIX . "globsettings" );
            if(isset($metas) && !empty($metas)){
                foreach($metas as $m_key => $m_value){
                    $result = $wpdb->update(
                        $dictionary_global_settings,
                        array(
                            'meta_value' => $m_value,
                            'note'       => $notes,
                            'options'    => $options
                        ),
                        array(
                            'meta_key' => $m_key
                        ),
                        array(
                            '%s', '%s', '%s'
                        ),
                        array(
                            '%s'
                        )
                    );

                }
                if($result >= 0){
                    return true;
                }
            }
            return false;
        }

        // Get global settings
        public static function ays_pd_get_setting(){
            global $wpdb;
            $settings_table = $wpdb->prefix . PERSONAL_DICTIONARY_DB_PREFIX . "globsettings";
            $sql = "SELECT * FROM ".$settings_table;
            $result = $wpdb->get_results($sql ,"ARRAY_A");
            $values = array();
            if(isset($result) && !empty($result)){
                foreach($result as $key => $value){
                    $values[$value['meta_key']] = $value["meta_value"];
                }
                return $values;
            }
            return false;
        }
}
?>